diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ipv6-header.cc ns-3.35/src/internet/model/ipv6-header.cc
--- ns-3.34/src/internet/model/ipv6-header.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ipv6-header.cc	2021-10-01 13:26:47.000000000 -0700
@@ -38,8 +38,8 @@
     m_nextHeader (0),
     m_hopLimit (0)
 {
-  SetSourceAddress (Ipv6Address ("::"));
-  SetDestinationAddress (Ipv6Address ("::"));
+  SetSource (Ipv6Address ("::"));
+  SetDestination (Ipv6Address ("::"));
 }
 
 void Ipv6Header::SetTrafficClass (uint8_t traffic)
@@ -92,26 +92,46 @@
   return m_hopLimit;
 }
 
-void Ipv6Header::SetSourceAddress (Ipv6Address src)
+void Ipv6Header::SetSource (Ipv6Address src)
 {
   m_sourceAddress = src;
 }
 
-Ipv6Address Ipv6Header::GetSourceAddress () const
+void Ipv6Header::SetSourceAddress (Ipv6Address src)
+{
+  SetSource (src);
+}
+
+Ipv6Address Ipv6Header::GetSource () const
 {
   return m_sourceAddress;
 }
 
-void Ipv6Header::SetDestinationAddress (Ipv6Address dst)
+Ipv6Address Ipv6Header::GetSourceAddress () const
+{
+  return GetSource ();
+}
+
+void Ipv6Header::SetDestination (Ipv6Address dst)
 {
   m_destinationAddress = dst;
 }
 
-Ipv6Address Ipv6Header::GetDestinationAddress () const
+void Ipv6Header::SetDestinationAddress (Ipv6Address dst)
+{
+  SetDestination (dst);
+}
+
+Ipv6Address Ipv6Header::GetDestination () const
 {
   return m_destinationAddress;
 }
 
+Ipv6Address Ipv6Header::GetDestinationAddress () const
+{
+  return GetDestination ();
+}
+
 TypeId Ipv6Header::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::Ipv6Header")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ipv6-header.h ns-3.35/src/internet/model/ipv6-header.h
--- ns-3.34/src/internet/model/ipv6-header.h	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ipv6-header.h	2021-10-01 13:26:47.000000000 -0700
@@ -23,6 +23,7 @@
 
 #include "ns3/header.h"
 #include "ns3/ipv6-address.h"
+#include "ns3/deprecated.h"
 
 namespace ns3 {
 
@@ -226,24 +227,56 @@
    * \brief Set the "Source address" field.
    * \param src the source address
    */
+  void SetSource (Ipv6Address src);
+
+  /**
+   * \brief Set the "Source address" field.
+   * \deprecated Use SetSource () function instead (same functionality)
+   * \param src the source address
+   */
+  NS_DEPRECATED_3_35
   void SetSourceAddress (Ipv6Address src);
 
   /**
    * \brief Get the "Source address" field.
    * \return the source address
    */
+  Ipv6Address GetSource (void) const;
+
+  /**
+   * \brief Get the "Source address" field.
+   * \deprecated Use GetSource () function instead (same functionality)
+   * \return the source address
+   */
+  NS_DEPRECATED_3_35
   Ipv6Address GetSourceAddress (void) const;
 
   /**
    * \brief Set the "Destination address" field.
    * \param dst the destination address
    */
+  void SetDestination (Ipv6Address dst);
+
+  /**
+   * \brief Set the "Destination address" field.
+   * \deprecated Use SetDestination () function instead (same functionality)
+   * \param dst the destination address
+   */
+  NS_DEPRECATED_3_35
   void SetDestinationAddress (Ipv6Address dst);
 
   /**
    * \brief Get the "Destination address" field.
    * \return the destination address
    */
+  Ipv6Address GetDestination (void) const;
+
+  /**
+   * \brief Get the "Destination address" field.
+   * \deprecated Use GetDestination () function instead (same functionality)
+   * \return the destination address
+   */
+  NS_DEPRECATED_3_35
   Ipv6Address GetDestinationAddress (void) const;
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ipv6-l3-protocol.cc ns-3.35/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.34/src/internet/model/ipv6-l3-protocol.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ipv6-l3-protocol.cc	2021-10-01 13:26:47.000000000 -0700
@@ -962,7 +962,7 @@
   if (ndiscCache)
     {
       // case one, it's a a direct routing.
-      NdiscCache::Entry *entry = ndiscCache->Lookup (hdr.GetSourceAddress ());
+      NdiscCache::Entry *entry = ndiscCache->Lookup (hdr.GetSource ());
       if (entry)
         {
           entry->UpdateReachableTimer ();
@@ -1003,7 +1003,7 @@
 
       if (ipv6Extension)
         {
-          ipv6Extension->Process (packet, 0, hdr, hdr.GetDestinationAddress (), (uint8_t *)0, stopProcessing, isDropped, dropReason);
+          ipv6Extension->Process (packet, 0, hdr, hdr.GetDestination (), (uint8_t *)0, stopProcessing, isDropped, dropReason);
         }
 
       if (isDropped)
@@ -1017,21 +1017,21 @@
         }
     }
 
-  if (hdr.GetDestinationAddress ().IsAllNodesMulticast ())
+  if (hdr.GetDestination ().IsAllNodesMulticast ())
     {
       LocalDeliver (packet, hdr, interface);
       return;
     }
-  else if (hdr.GetDestinationAddress ().IsAllRoutersMulticast() && ipv6Interface->IsForwarding ())
+  else if (hdr.GetDestination ().IsAllRoutersMulticast() && ipv6Interface->IsForwarding ())
     {
       LocalDeliver (packet, hdr, interface);
       return;
     }
-  else if (hdr.GetDestinationAddress ().IsMulticast ())
+  else if (hdr.GetDestination ().IsMulticast ())
     {
-      bool isSolicited = ipv6Interface->IsSolicitedMulticastAddress (hdr.GetDestinationAddress ());
-      bool isRegisteredOnInterface = IsRegisteredMulticastAddress (hdr.GetDestinationAddress (), interface);
-      bool isRegisteredGlobally = IsRegisteredMulticastAddress (hdr.GetDestinationAddress ());
+      bool isSolicited = ipv6Interface->IsSolicitedMulticastAddress (hdr.GetDestination ());
+      bool isRegisteredOnInterface = IsRegisteredMulticastAddress (hdr.GetDestination (), interface);
+      bool isRegisteredGlobally = IsRegisteredMulticastAddress (hdr.GetDestination ());
       if (isSolicited || isRegisteredGlobally || isRegisteredOnInterface)
         {
           LocalDeliver (packet, hdr, interface);
@@ -1048,7 +1048,7 @@
             {
               Ipv6InterfaceAddress iaddr = GetAddress (j, i);
               Ipv6Address addr = iaddr.GetAddress ();
-              if (addr == hdr.GetDestinationAddress ())
+              if (addr == hdr.GetDestination ())
                 {
                   if (j == interface)
                     {
@@ -1056,7 +1056,7 @@
                     }
                   else
                     {
-                      NS_LOG_LOGIC ("For me (destination " << addr << " match) on another interface " << hdr.GetDestinationAddress ());
+                      NS_LOG_LOGIC ("For me (destination " << addr << " match) on another interface " << hdr.GetDestination ());
                     }
                   LocalDeliver (packet, hdr, interface);
                   return;
@@ -1107,7 +1107,7 @@
   std::list<Ipv6ExtensionFragment::Ipv6PayloadHeaderPair> fragments;
 
   // Check if we have a Path MTU stored. If so, use it. Else, use the link MTU.
-  size_t targetMtu = (size_t)(m_pmtuCache->GetPmtu (ipHeader.GetDestinationAddress()));
+  size_t targetMtu = (size_t)(m_pmtuCache->GetPmtu (ipHeader.GetDestination()));
   if (targetMtu == 0)
     {
       targetMtu = dev->GetMtu ();
@@ -1122,7 +1122,7 @@
         {
           for (uint32_t j=0; j<GetNAddresses(i); j++ )
             {
-              if (GetAddress(i,j).GetAddress() == ipHeader.GetSourceAddress())
+              if (GetAddress(i,j).GetAddress() == ipHeader.GetSource())
                 {
                   fromMe = true;
                   break;
@@ -1135,7 +1135,7 @@
           if ( icmpv6 )
             {
               packet->AddHeader(ipHeader);
-              icmpv6->SendErrorTooBig (packet, ipHeader.GetSourceAddress (), dev->GetMtu ());
+              icmpv6->SendErrorTooBig (packet, ipHeader.GetSource (), dev->GetMtu ());
             }
           return;
         }
@@ -1180,7 +1180,7 @@
     {
       if (outInterface->IsUp ())
         {
-          NS_LOG_LOGIC ("Send to destination " << ipHeader.GetDestinationAddress ());
+          NS_LOG_LOGIC ("Send to destination " << ipHeader.GetDestination ());
 
           if (fragments.size () != 0)
             {
@@ -1189,18 +1189,18 @@
               for (std::list<Ipv6ExtensionFragment::Ipv6PayloadHeaderPair>::const_iterator it = fragments.begin (); it != fragments.end (); it++)
                 {
                   CallTxTrace (it->second, it->first, m_node->GetObject<Ipv6> (), interface);
-                  outInterface->Send (it->first, it->second, ipHeader.GetDestinationAddress ());
+                  outInterface->Send (it->first, it->second, ipHeader.GetDestination ());
                 }
             }
           else
             {
               CallTxTrace (ipHeader, packet, m_node->GetObject<Ipv6> (), interface);
-              outInterface->Send (packet, ipHeader, ipHeader.GetDestinationAddress ());
+              outInterface->Send (packet, ipHeader, ipHeader.GetDestination ());
             }
         }
       else
         {
-          NS_LOG_LOGIC ("Dropping-- outgoing interface is down: " << ipHeader.GetDestinationAddress ());
+          NS_LOG_LOGIC ("Dropping-- outgoing interface is down: " << ipHeader.GetDestination ());
           m_dropTrace (ipHeader, packet, DROP_INTERFACE_DOWN, m_node->GetObject<Ipv6> (), interface);
         }
     }
@@ -1212,7 +1212,7 @@
   NS_LOG_LOGIC ("Forwarding logic for node: " << m_node->GetId ());
 
   // Drop RFC 3849 packets: 2001:db8::/32
-  if (header.GetDestinationAddress().IsDocumentation ())
+  if (header.GetDestination().IsDocumentation ())
     {
       NS_LOG_WARN ("Received a packet for 2001:db8::/32 (documentation class).  Drop.");
       m_dropTrace (header, p, DROP_ROUTE_ERROR, m_node->GetObject<Ipv6> (), 0);
@@ -1224,7 +1224,7 @@
   Ptr<Packet> packet = p->Copy ();
   ipHeader.SetHopLimit (ipHeader.GetHopLimit () - 1);
 
-  if (ipHeader.GetSourceAddress ().IsLinkLocal ())
+  if (ipHeader.GetSource ().IsLinkLocal ())
     {
       /* no forward for link-local address */
       return;
@@ -1235,10 +1235,10 @@
       NS_LOG_WARN ("TTL exceeded.  Drop.");
       m_dropTrace (ipHeader, packet, DROP_TTL_EXPIRED, m_node->GetObject<Ipv6> (), 0);
       // Do not reply to multicast IPv6 address
-      if (ipHeader.GetDestinationAddress ().IsMulticast () == false)
+      if (ipHeader.GetDestination ().IsMulticast () == false)
         {
           packet->AddHeader (ipHeader);
-          GetIcmpv6 ()->SendErrorTimeExceeded (packet, ipHeader.GetSourceAddress (), Icmpv6Header::ICMPV6_HOPLIMIT);
+          GetIcmpv6 ()->SendErrorTimeExceeded (packet, ipHeader.GetSource (), Icmpv6Header::ICMPV6_HOPLIMIT);
         }
       return;
     }
@@ -1260,8 +1260,8 @@
       NS_LOG_LOGIC ("ICMPv6 redirect!");
       Ptr<Icmpv6L4Protocol> icmpv6 = GetIcmpv6 ();
       Address hardwareTarget;
-      Ipv6Address dst = header.GetDestinationAddress ();
-      Ipv6Address src = header.GetSourceAddress ();
+      Ipv6Address dst = header.GetDestination ();
+      Ipv6Address src = header.GetSource ();
       Ipv6Address target = rtentry->GetGateway ();
       Ptr<Packet> copy = p->Copy ();
 
@@ -1313,8 +1313,8 @@
         }
       NS_LOG_LOGIC ("Forward multicast via interface " << interfaceId);
       Ptr<Ipv6Route> rtentry = Create<Ipv6Route> ();
-      rtentry->SetSource (h.GetSourceAddress ());
-      rtentry->SetDestination (h.GetDestinationAddress ());
+      rtentry->SetSource (h.GetSource ());
+      rtentry->SetDestination (h.GetDestination ());
       rtentry->SetGateway (Ipv6Address::GetAny ());
       rtentry->SetOutputDevice (GetNetDevice (interfaceId));
       SendRealOut (rtentry, packet, h);
@@ -1329,8 +1329,8 @@
   Ptr<IpL4Protocol> protocol = 0;
   Ptr<Ipv6ExtensionDemux> ipv6ExtensionDemux = m_node->GetObject<Ipv6ExtensionDemux> ();
   Ptr<Ipv6Extension> ipv6Extension = 0;
-  Ipv6Address src = ip.GetSourceAddress ();
-  Ipv6Address dst = ip.GetDestinationAddress ();
+  Ipv6Address src = ip.GetSource ();
+  Ipv6Address dst = ip.GetDestination ();
   uint8_t nextHeader = ip.GetNextHeader ();
   uint8_t nextHeaderPosition = 0;
   bool isDropped = false;
@@ -1419,14 +1419,14 @@
                 case IpL4Protocol::RX_ENDPOINT_CLOSED:
                   break;
                 case IpL4Protocol::RX_ENDPOINT_UNREACH:
-                  if (ip.GetDestinationAddress ().IsMulticast ())
+                  if (ip.GetDestination ().IsMulticast ())
                     {
                       /* do not rely on multicast address */
                       break;
                     }
 
                   copy->AddHeader (ip);
-                  GetIcmpv6 ()->SendErrorDestinationUnreachable (copy, ip.GetSourceAddress (), Icmpv6Header::ICMPV6_PORT_UNREACHABLE);
+                  GetIcmpv6 ()->SendErrorDestinationUnreachable (copy, ip.GetSource (), Icmpv6Header::ICMPV6_PORT_UNREACHABLE);
                 }
             }
         }
@@ -1441,11 +1441,11 @@
 
   m_dropTrace (ipHeader, p, DROP_ROUTE_ERROR, m_node->GetObject<Ipv6> (), 0);
 
-  if (!ipHeader.GetDestinationAddress ().IsMulticast ())
+  if (!ipHeader.GetDestination ().IsMulticast ())
     {
       Ptr<Packet> packet = p->Copy ();
       packet->AddHeader (ipHeader);
-      GetIcmpv6 ()->SendErrorDestinationUnreachable (packet, ipHeader.GetSourceAddress (), Icmpv6Header::ICMPV6_NO_ROUTE);
+      GetIcmpv6 ()->SendErrorDestinationUnreachable (packet, ipHeader.GetSource (), Icmpv6Header::ICMPV6_NO_ROUTE);
     }
 }
 
@@ -1454,8 +1454,8 @@
   NS_LOG_FUNCTION (this << src << dst << (uint32_t)protocol << (uint32_t)payloadSize << (uint32_t)ttl << (uint32_t)tclass);
   Ipv6Header hdr;
 
-  hdr.SetSourceAddress (src);
-  hdr.SetDestinationAddress (dst);
+  hdr.SetSource (src);
+  hdr.SetDestination (dst);
   hdr.SetNextHeader (protocol);
   hdr.SetPayloadLength (payloadSize);
   hdr.SetHopLimit (ttl);
@@ -1635,7 +1635,7 @@
       std::list<NdiscCache::Ipv6PayloadHeaderPair> waiting = entry->MarkReachable (entry->GetMacAddress ());
       for (std::list<NdiscCache::Ipv6PayloadHeaderPair>::const_iterator it = waiting.begin (); it != waiting.end (); it++)
         {
-          ndiscCache->GetInterface ()->Send (it->first, it->second, it->second.GetSourceAddress ());
+          ndiscCache->GetInterface ()->Send (it->first, it->second, it->second.GetSource ());
         }
       entry->ClearWaitingPacket ();
       entry->StartReachableTimer ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ipv6-list-routing.cc ns-3.35/src/internet/model/ipv6-list-routing.cc
--- ns-3.34/src/internet/model/ipv6-list-routing.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ipv6-list-routing.cc	2021-10-01 13:26:47.000000000 -0700
@@ -73,14 +73,14 @@
 Ptr<Ipv6Route>
 Ipv6ListRouting::RouteOutput (Ptr<Packet> p, const Ipv6Header &header, Ptr<NetDevice> oif, enum Socket::SocketErrno &sockerr)
 {
-  NS_LOG_FUNCTION (this << header.GetDestinationAddress () << header.GetSourceAddress () << oif);
+  NS_LOG_FUNCTION (this << header.GetDestination () << header.GetSource () << oif);
   Ptr<Ipv6Route> route;
 
   for (Ipv6RoutingProtocolList::const_iterator i = m_routingProtocols.begin ();
        i != m_routingProtocols.end (); i++)
     {
       NS_LOG_LOGIC ("Checking protocol " << (*i).second->GetInstanceTypeId () << " with priority " << (*i).first);
-      NS_LOG_LOGIC ("Requesting source address for destination " << header.GetDestinationAddress ());
+      NS_LOG_LOGIC ("Requesting source address for destination " << header.GetDestination ());
       route = (*i).second->RouteOutput (p, header, oif, sockerr);
       if (route)
         {
@@ -107,7 +107,7 @@
   NS_ASSERT (m_ipv6 != 0);
   // Check if input device supports IP
   NS_ASSERT (m_ipv6->GetInterfaceForDevice (idev) >= 0);
-  Ipv6Address dst = header.GetDestinationAddress ();
+  Ipv6Address dst = header.GetDestination ();
 
   // Check if input device supports IP forwarding
   uint32_t iif = m_ipv6->GetInterfaceForDevice (idev);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ipv6-queue-disc-item.cc ns-3.35/src/internet/model/ipv6-queue-disc-item.cc
--- ns-3.34/src/internet/model/ipv6-queue-disc-item.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ipv6-queue-disc-item.cc	2021-10-01 13:26:47.000000000 -0700
@@ -115,8 +115,8 @@
 {
   NS_LOG_FUNCTION (this << perturbation);
 
-  Ipv6Address src = m_header.GetSourceAddress ();
-  Ipv6Address dest = m_header.GetDestinationAddress ();
+  Ipv6Address src = m_header.GetSource ();
+  Ipv6Address dest = m_header.GetDestination ();
   uint8_t prot = m_header.GetNextHeader ();
 
   TcpHeader tcpHdr;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ipv6-raw-socket-impl.cc ns-3.35/src/internet/model/ipv6-raw-socket-impl.cc
--- ns-3.34/src/internet/model/ipv6-raw-socket-impl.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ipv6-raw-socket-impl.cc	2021-10-01 13:26:47.000000000 -0700
@@ -242,7 +242,7 @@
   if (ipv6->GetRoutingProtocol ())
     {
       Ipv6Header hdr;
-      hdr.SetDestinationAddress (dst);
+      hdr.SetDestination (dst);
       SocketErrno err = ERROR_NOTERROR;
       Ptr<Ipv6Route> route = 0;
       Ptr<NetDevice> oif = m_boundnetdevice; //specify non-zero if bound to a specific device
@@ -412,8 +412,8 @@
         }
     }
 
-  if ((m_src == Ipv6Address::GetAny () || hdr.GetDestinationAddress () == m_src) && 
-      (m_dst == Ipv6Address::GetAny () || hdr.GetSourceAddress () == m_dst) &&
+  if ((m_src == Ipv6Address::GetAny () || hdr.GetDestination () == m_src) && 
+      (m_dst == Ipv6Address::GetAny () || hdr.GetSource () == m_dst) &&
       hdr.GetNextHeader () == m_protocol)
     {
       Ptr<Packet> copy = p->Copy ();
@@ -437,7 +437,7 @@
         {
           Ipv6PacketInfoTag tag;
           copy->RemovePacketTag (tag);
-          tag.SetAddress (hdr.GetDestinationAddress ());
+          tag.SetAddress (hdr.GetDestination ());
           tag.SetHoplimit (hdr.GetHopLimit ());
           tag.SetTrafficClass (hdr.GetTrafficClass ());
           tag.SetRecvIf (device->GetIfIndex ());
@@ -462,7 +462,7 @@
       copy->AddHeader (hdr);
       Data data;
       data.packet = copy;
-      data.fromIp = hdr.GetSourceAddress ();
+      data.fromIp = hdr.GetSource ();
       data.fromProtocol = hdr.GetNextHeader ();
       m_data.push_back (data);
       NotifyDataRecv ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ipv6-static-routing.cc ns-3.35/src/internet/model/ipv6-static-routing.cc
--- ns-3.34/src/internet/model/ipv6-static-routing.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ipv6-static-routing.cc	2021-10-01 13:26:47.000000000 -0700
@@ -595,7 +595,7 @@
 Ptr<Ipv6Route> Ipv6StaticRouting::RouteOutput (Ptr<Packet> p, const Ipv6Header &header, Ptr<NetDevice> oif, Socket::SocketErrno &sockerr)
 {
   NS_LOG_FUNCTION (this << header << oif);
-  Ipv6Address destination = header.GetDestinationAddress ();
+  Ipv6Address destination = header.GetDestination ();
   Ptr<Ipv6Route> rtentry = 0;
 
   if (destination.IsMulticast ())
@@ -625,19 +625,19 @@
                                     UnicastForwardCallback ucb, MulticastForwardCallback mcb,
                                     LocalDeliverCallback lcb, ErrorCallback ecb)
 {
-  NS_LOG_FUNCTION (this << p << header << header.GetSourceAddress () << header.GetDestinationAddress () << idev);
+  NS_LOG_FUNCTION (this << p << header << header.GetSource () << header.GetDestination () << idev);
   NS_ASSERT (m_ipv6 != 0);
   // Check if input device supports IP
   NS_ASSERT (m_ipv6->GetInterfaceForDevice (idev) >= 0);
   uint32_t iif = m_ipv6->GetInterfaceForDevice (idev);
-  Ipv6Address dst = header.GetDestinationAddress ();
+  Ipv6Address dst = header.GetDestination ();
 
   // Multicast recognition; handle local delivery here
   if (dst.IsMulticast ())
     {
       NS_LOG_LOGIC ("Multicast destination");
-      Ptr<Ipv6MulticastRoute> mrtentry = LookupStatic (header.GetSourceAddress (),
-                                                       header.GetDestinationAddress (), m_ipv6->GetInterfaceForDevice (idev));
+      Ptr<Ipv6MulticastRoute> mrtentry = LookupStatic (header.GetSource (),
+                                                       header.GetDestination (), m_ipv6->GetInterfaceForDevice (idev));
 
       // \todo check if we want to forward up the packet
       if (mrtentry)
@@ -665,7 +665,7 @@
     }
   // Next, try to find a route
   NS_LOG_LOGIC ("Unicast destination");
-  Ptr<Ipv6Route> rtentry = LookupStatic (header.GetDestinationAddress ());
+  Ptr<Ipv6Route> rtentry = LookupStatic (header.GetDestination ());
 
   if (rtentry != 0)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/ripng.cc ns-3.35/src/internet/model/ripng.cc
--- ns-3.34/src/internet/model/ripng.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/ripng.cc	2021-10-01 13:26:47.000000000 -0700
@@ -183,7 +183,7 @@
 {
   NS_LOG_FUNCTION (this << header << oif);
 
-  Ipv6Address destination = header.GetDestinationAddress ();
+  Ipv6Address destination = header.GetDestination ();
   Ptr<Ipv6Route> rtentry = 0;
 
   if (destination.IsMulticast ())
@@ -213,13 +213,13 @@
                         UnicastForwardCallback ucb, MulticastForwardCallback mcb,
                         LocalDeliverCallback lcb, ErrorCallback ecb)
 {
-  NS_LOG_FUNCTION (this << p << header << header.GetSourceAddress () << header.GetDestinationAddress () << idev);
+  NS_LOG_FUNCTION (this << p << header << header.GetSource () << header.GetDestination () << idev);
 
   NS_ASSERT (m_ipv6 != 0);
   // Check if input device supports IP
   NS_ASSERT (m_ipv6->GetInterfaceForDevice (idev) >= 0);
   uint32_t iif = m_ipv6->GetInterfaceForDevice (idev);
-  Ipv6Address dst = header.GetDestinationAddress ();
+  Ipv6Address dst = header.GetDestination ();
 
   if (dst.IsMulticast ())
     {
@@ -227,8 +227,8 @@
       return false; // Let other routing protocols try to handle this
     }
 
-  if (header.GetDestinationAddress ().IsLinkLocal () ||
-      header.GetSourceAddress ().IsLinkLocal ())
+  if (header.GetDestination ().IsLinkLocal () ||
+      header.GetSource ().IsLinkLocal ())
     {
       NS_LOG_LOGIC ("Dropping packet not for me and with src or dst LinkLocal");
       if (!ecb.IsNull ())
@@ -250,7 +250,7 @@
     }
   // Next, try to find a route
   NS_LOG_LOGIC ("Unicast destination");
-  Ptr<Ipv6Route> rtentry = Lookup (header.GetDestinationAddress ());
+  Ptr<Ipv6Route> rtentry = Lookup (header.GetDestination ());
 
   if (rtentry != 0)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/tcp-cubic.cc ns-3.35/src/internet/model/tcp-cubic.cc
--- ns-3.34/src/internet/model/tcp-cubic.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/tcp-cubic.cc	2021-10-01 13:26:47.000000000 -0700
@@ -397,10 +397,8 @@
 {
   NS_LOG_FUNCTION (this << tcb << bytesInFlight);
 
-  // Without inflation and deflation, these two are the same
-  uint32_t segInFlight = bytesInFlight / tcb->m_segmentSize;
   uint32_t segCwnd = tcb->GetCwndInSegments ();
-  NS_LOG_DEBUG ("Loss at cWnd=" << segCwnd << " in flight=" << segInFlight);
+  NS_LOG_DEBUG ("Loss at cWnd=" << segCwnd << " segments in flight=" << bytesInFlight / tcb->m_segmentSize);
 
   /* Wmax and fast convergence */
   if (segCwnd < m_lastMaxCwnd && m_fastConvergence)
@@ -415,7 +413,7 @@
   m_epochStart = Time::Min ();    // end of epoch
 
   /* Formula taken from the Linux kernel */
-  uint32_t ssThresh = std::max (static_cast<uint32_t> (segInFlight * m_beta ), 2U) * tcb->m_segmentSize;
+  uint32_t ssThresh = std::max (static_cast<uint32_t> (segCwnd * m_beta ), 2U) * tcb->m_segmentSize;
 
   NS_LOG_DEBUG ("SsThresh = " << ssThresh);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/tcp-l4-protocol.cc ns-3.35/src/internet/model/tcp-l4-protocol.cc
--- ns-3.34/src/internet/model/tcp-l4-protocol.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/tcp-l4-protocol.cc	2021-10-01 13:26:47.000000000 -0700
@@ -468,8 +468,8 @@
 
           src = Ipv6Address::MakeIpv4MappedAddress (incomingIpHeader.GetSource ());
           dst = Ipv6Address::MakeIpv4MappedAddress (incomingIpHeader.GetDestination ());
-          ipv6Header.SetSourceAddress (src);
-          ipv6Header.SetDestinationAddress (dst);
+          ipv6Header.SetSource (src);
+          ipv6Header.SetDestination (dst);
           return (this->Receive (packet, ipv6Header, fakeInterface));
         }
 
@@ -503,8 +503,8 @@
                         Ipv6Header const &incomingIpHeader,
                         Ptr<Ipv6Interface> interface)
 {
-  NS_LOG_FUNCTION (this << packet << incomingIpHeader.GetSourceAddress () <<
-                   incomingIpHeader.GetDestinationAddress ());
+  NS_LOG_FUNCTION (this << packet << incomingIpHeader.GetSource () <<
+                   incomingIpHeader.GetDestination ());
 
   TcpHeader incomingTcpHeader;
   IpL4Protocol::RxStatus checksumControl;
@@ -514,8 +514,8 @@
   // order to avoid re-calculating TCP checksums for v4-mapped packets?
 
   checksumControl = PacketReceived (packet, incomingTcpHeader,
-                                    incomingIpHeader.GetSourceAddress (),
-                                    incomingIpHeader.GetDestinationAddress ());
+                                    incomingIpHeader.GetSource (),
+                                    incomingIpHeader.GetDestination ());
 
   if (checksumControl != IpL4Protocol::RX_OK)
     {
@@ -523,21 +523,21 @@
     }
 
   Ipv6EndPointDemux::EndPoints endPoints =
-    m_endPoints6->Lookup (incomingIpHeader.GetDestinationAddress (),
+    m_endPoints6->Lookup (incomingIpHeader.GetDestination (),
                           incomingTcpHeader.GetDestinationPort (),
-                          incomingIpHeader.GetSourceAddress (),
+                          incomingIpHeader.GetSource (),
                           incomingTcpHeader.GetSourcePort (), interface);
   if (endPoints.empty ())
     {
       NS_LOG_LOGIC ("TcpL4Protocol " << this << " received a packet but"
                     " no endpoints matched." <<
-                    " destination IP: " << incomingIpHeader.GetDestinationAddress () <<
+                    " destination IP: " << incomingIpHeader.GetDestination () <<
                     " destination port: "<< incomingTcpHeader.GetDestinationPort () <<
-                    " source IP: " << incomingIpHeader.GetSourceAddress () <<
+                    " source IP: " << incomingIpHeader.GetSource () <<
                     " source port: "<< incomingTcpHeader.GetSourcePort ());
 
-      NoEndPointsFound (incomingTcpHeader, incomingIpHeader.GetSourceAddress (),
-                        incomingIpHeader.GetDestinationAddress ());
+      NoEndPointsFound (incomingTcpHeader, incomingIpHeader.GetSource (),
+                        incomingIpHeader.GetDestination ());
 
       return IpL4Protocol::RX_ENDPOINT_CLOSED;
     }
@@ -635,8 +635,8 @@
   if (ipv6 != 0)
     {
       Ipv6Header header;
-      header.SetSourceAddress (saddr);
-      header.SetDestinationAddress (daddr);
+      header.SetSource (saddr);
+      header.SetDestination (daddr);
       header.SetNextHeader (PROT_NUMBER);
       Socket::SocketErrno errno_;
       Ptr<Ipv6Route> route;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/tcp-socket-base.cc ns-3.35/src/internet/model/tcp-socket-base.cc
--- ns-3.34/src/internet/model/tcp-socket-base.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/tcp-socket-base.cc	2021-10-01 13:26:47.000000000 -0700
@@ -1184,8 +1184,8 @@
                 " to " << m_endPoint6->GetLocalAddress () <<
                 ":" << m_endPoint6->GetLocalPort ());
 
-  Address fromAddress = Inet6SocketAddress (header.GetSourceAddress (), port);
-  Address toAddress = Inet6SocketAddress (header.GetDestinationAddress (),
+  Address fromAddress = Inet6SocketAddress (header.GetSource (), port);
+  Address toAddress = Inet6SocketAddress (header.GetDestination (),
                                           m_endPoint6->GetLocalPort ());
 
   TcpHeader tcpHeader;
@@ -2865,7 +2865,7 @@
   // Create a dummy packet, then ask the routing function for the best output
   // interface's address
   Ipv6Header header;
-  header.SetDestinationAddress (m_endPoint6->GetPeerAddress ());
+  header.SetDestination (m_endPoint6->GetPeerAddress ());
   Socket::SocketErrno errno_;
   Ptr<Ipv6Route> route;
   Ptr<NetDevice> oif = m_boundnetdevice;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/tcp-westwood.cc ns-3.35/src/internet/model/tcp-westwood.cc
--- ns-3.34/src/internet/model/tcp-westwood.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/tcp-westwood.cc	2021-10-01 13:26:47.000000000 -0700
@@ -70,7 +70,8 @@
   m_lastSampleBW (0),
   m_lastBW (0),
   m_ackedSegments (0),
-  m_IsCount (false)
+  m_IsCount (false),
+  m_lastAck (0)
 {
   NS_LOG_FUNCTION (this);
 }
@@ -131,8 +132,15 @@
 
   m_currentBW = m_ackedSegments * tcb->m_segmentSize / rtt.GetSeconds ();
 
-  if (m_pType == TcpWestwood::WESTWOODPLUS)
+  if (m_pType == TcpWestwood::WESTWOOD)
+    {
+      Time currentAck = Simulator::Now ();
+      m_currentBW = m_ackedSegments * tcb->m_segmentSize / (currentAck - m_lastAck).GetSeconds ();
+      m_lastAck = currentAck;
+    }
+  else if (m_pType == TcpWestwood::WESTWOODPLUS)
     {
+      m_currentBW = m_ackedSegments * tcb->m_segmentSize / rtt.GetSeconds ();
       m_IsCount = false;
     }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/internet/model/tcp-westwood.h ns-3.35/src/internet/model/tcp-westwood.h
--- ns-3.34/src/internet/model/tcp-westwood.h	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/internet/model/tcp-westwood.h	2021-10-01 13:26:47.000000000 -0700
@@ -133,6 +133,7 @@
   uint32_t               m_ackedSegments;          //!< The number of segments ACKed between RTTs
   bool                   m_IsCount;                //!< Start keeping track of m_ackedSegments for Westwood+ if TRUE
   EventId                m_bwEstimateEvent;        //!< The BW estimation event for Westwood+
+  Time                   m_lastAck;                //!< The last ACK time
 
 };
 
